<?php
/*
Plugin Name: Multi-RSS Reader
Plugin URI: http://ichirowo.com/2011/10/multi-rss-reader/
Description: 複数のRSSリーダーの見出しをまとめて時系列順に表示するウィジェット
Version: 0.5
Author: @ichirowo
Author URI: http://ichirowo.com/
*/


class wp_multi_rss_reader extends WP_Widget {
	// コンストラクタ
	function wp_multi_rss_reader() {
		//ウィジェットの初期設定
		$widget_ops = array(
			'description' => '複数のRSSリーダーの見出しを時系列順に表示'
		);
		parent::WP_Widget(false, $name = 'Multi-RSS Reader',$widget_ops);
	}

	//管理画面にフォームを表示する処理
	function form($instance) {
		// 設定が保存されていない場合はデフォルト値を設定
		$instance = wp_parse_args((array)$instance, array('title' => 'Multi-RSS Reader','number' => 10,'cachetime' => 10));
?>
		<p>
		<?php _e('タイトル:'); ?>
		<label for="<?php echo $this->get_field_id('title'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" /></label>
		</p>

		<?php _e('表示する件数:'); ?>
		<label for="<?php echo $this->get_field_id('number'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo esc_attr($instance['number']); ?>" style="width:60px;" /></label>
		(1-30)
		</p>
		
		<p>
		<?php _e('キャッシュ時間:(分)'); ?>
		<label for="<?php echo $this->get_field_id('cachetime'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('cachetime'); ?>" name="<?php echo $this->get_field_name('cachetime'); ?>" type="text" value="<?php echo esc_attr($instance['cachetime']); ?>" style="width:60px;" /></label>
		(0-300)
		</p>

		<p>
		<?php _e('RSS URL: (http://hoge.co.jp/rss.xml)'); ?>
		<label for="<?php echo $this->get_field_id('RssUrl1'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl1'); ?>" name="<?php echo $this->get_field_name('RssUrl1'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl1']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl2'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl2'); ?>" name="<?php echo $this->get_field_name('RssUrl2'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl2']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl3'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl3'); ?>" name="<?php echo $this->get_field_name('RssUrl3'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl3']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl4'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl4'); ?>" name="<?php echo $this->get_field_name('RssUrl4'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl4']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl5'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl5'); ?>" name="<?php echo $this->get_field_name('RssUrl5'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl5']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl6'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl6'); ?>" name="<?php echo $this->get_field_name('RssUrl6'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl6']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl7'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl7'); ?>" name="<?php echo $this->get_field_name('RssUrl7'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl7']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl8'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl8'); ?>" name="<?php echo $this->get_field_name('RssUrl8'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl8']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl9'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl9'); ?>" name="<?php echo $this->get_field_name('RssUrl9'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl9']); ?>" /></label>
		<label for="<?php echo $this->get_field_id('RssUrl10'); ?>"> <input class="widefat" id="<?php echo $this->get_field_id('RssUrl10'); ?>" name="<?php echo $this->get_field_name('RssUrl10'); ?>" type="text" value="<?php echo esc_attr($instance['RssUrl10']); ?>" /></label>
		</p>

<?php 
	}

	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		unset($instance);
		$instance = $new_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		if (!$instance['title']) {
			// タイトルが空白の場合、元の値に戻してエラー表示
			$this->m_error = '<span style="color:#ff0000;">タイトルが空白です。元の値に戻します。</span>';
			$instance['title'] = strip_tags($old_instance['title']);
		}
	
	    //入力値のチェック
		$instance['number'] = mb_convert_kana($instance['number'],"as");
		$instance['number'] = trim($instance['number']);
		if($instance['number'] <= 0 or $instance['number'] > 30){
			$instance['number'] = 10;
		}
	    //入力値のチェック
		$instance['cachetime'] = mb_convert_kana($instance['cachetime'],"as");
		$instance['cachetime'] = trim($instance['cachetime']);
		if($instance['cachetime'] < 0 or $instance['cachetime'] > 300 or !is_numeric ( $instance['cachetime'] )){
			$instance['cachetime'] = 10;
		}
		
	    //アップデート内容を返す
	    return $instance;
	}

	function widget($args, $instance) {
		//ウィジェット表示部
		extract($args);
		$instance = wp_parse_args((array)$instance, array('title' => '', 'number' => 10, 'cachetime' => 10));
		// タイトルはフィルタ処理
		$title = $instance['title'];
		$title = apply_filters('widget_title', $title);
		$number = $instance['number'];
		$cachetime = $instance['cachetime'];

		if($instance['RssUrl1']){
			$rss_url[] = $instance['RssUrl1'];
		}
		if($instance['RssUrl2']){
			$rss_url[] = $instance['RssUrl2'];
		}
		if($instance['RssUrl3']){
			$rss_url[] = $instance['RssUrl3'];
		}
		if($instance['RssUrl4']){
			$rss_url[] = $instance['RssUrl4'];
		}
		if($instance['RssUrl5']){
			$rss_url[] = $instance['RssUrl5'];
		}
		if($instance['RssUrl6']){
			$rss_url[] = $instance['RssUrl6'];
		}
		if($instance['RssUrl7']){
			$rss_url[] = $instance['RssUrl7'];
		}
		if($instance['RssUrl8']){
			$rss_url[] = $instance['RssUrl8'];
		}
		if($instance['RssUrl9']){
			$rss_url[] = $instance['RssUrl9'];
		}
		if($instance['RssUrl10']){
			$rss_url[] = $instance['RssUrl10'];
		}

		include_once(ABSPATH . WPINC . '/rss.php');
		
		//RSSのキャッシュ設定
		define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');
		define('MAGPIE_CACHE_DIR', './cache');
		define('MAGPIE_FETCH_TIME_OUT', 30);
		define('MAGPIE_CACHE_AGE', $cachetime * 60);
		
		//RSS読み出し配列に入力
		foreach ($rss_url as $key => $value) {
			$rss = fetch_rss($value);
			if($rss){
				foreach($rss->items as $k => $V){
					$items[$key][$k] = $V;
					$items[$key][$k]["sitetitle"] = $rss->channel['title'];
				}
			}else{
				echo "read_err";
			}
		}
		
		//配列に時間情報を足す
		if($items){
			$all_items = array();
			foreach($items as $key => $val){
				foreach ($val as $k => $v){
					//RSS0.9/2.0
					if($v['pubdate']){
						$utcsec = strtotime($v['pubdate']);			//UTC秒
						$wptimezonesec = $utcsec + get_option('gmt_offset') * 60 * 60;	//wp設定のタイムゾーンだけオフセット
						$v["sec"] = $wptimezonesec;			
					}
				
					//RSS1.0	
					if($v['dc']['date']){
						$utcsec = strtotime($v['dc']['date']);
						$wptimezonesec = $utcsec + get_option('gmt_offset') * 60 * 60;	//wp設定のタイムゾーンだけオフセット
						$v["sec"] = $wptimezonesec;			 
					}
					
					//atom	
					if($v['updated']){
						$utcsec = strtotime($v['updated']);
						$wptimezonesec = $utcsec + get_option('gmt_offset') * 60 * 60;	//wp設定のタイムゾーンだけオフセット
						$v["sec"] = $wptimezonesec;			 
					}
					
					//時間情報があったものだけを集める
					if(is_int($v["sec"])){
						$all_items[] = $v;
					}
				}
			}
				
			//ソート用配列準備
			foreach($all_items as $k => $v) {
				$dc[$k] = $v["sec"];
			}
			
			//ソート
			array_multisort($dc, SORT_DESC, $all_items);
			
			$all_items = array_slice($all_items, 0, $instance['number']);
			
			echo $before_widget."\n";
			echo $before_title.$title.$after_title."\n";
			echo '<ul class="recentEntries">';
	
			foreach($all_items as $k => $v) {
				echo '<li>';
				echo '<div><a href="'.esc_url($v["link"]).'" target="_blank">'.htmlspecialchars($v["title"]).'</a></div>';
				echo '<div>'.date("m/d H:i",$v["sec"])." ".htmlspecialchars($v["sitetitle"]).'</div>';
				echo '</li>';
			}
			echo '</ul>';
			echo $after_widget."\n";
		}else{
			echo $before_widget."\n";
			echo $before_title.$title.$after_title."\n";
			echo '<ul class="recentEntries">';
			echo '<li>';
			echo '<div>' . __('情報がありません') . '</div>';
			echo '</li>';
			echo '</ul>';
			echo $after_widget."\n";
		}

		wp_reset_query();
	}
// register
}

function wp_multi_rss_reader_Init() {
	//ウィジェットのクラス名を登録
	register_widget('wp_multi_rss_reader');
}
//widgets_initアクション時にwp_multi_rss_reader_Init関数を実行
add_action('widgets_init', 'wp_multi_rss_reader_Init');
?>